// Последнее обновление 2017-08-15 by Phisik
// Файл содержит дефолтные настройки системы
// Часть настроек меняется в файле configuration.h при выборе версий, внимательно с этим!



#define PR_REWRITE_EEPROM 0 // Константа, которая содержит признак необходимости перезаписи энергонезависимой памяти (1-254). 
                            // При запуске программы, значение 0-го байта ЕЕПРОМ сравнивается с этим значением, 
                            // и если они не совпадают, тогда энергонезависимая памиять переписывается текущими значениями переменных
                            // То есть для значений переменных из скетча в контроллер, ее значение надо поменять например с 9 до 10.


//#define TEST       // Раскомметировать, если нужно получать всяческие тестовые значения через Serial1
//#define TESTMEM     // Раскомметировать, если нужно получать всяческие тестовые значения через Serial1
//#define TESTGSM     // Раскомметировать, если нужно дублировать входящюю информацияю из serial2 (сотового телефона) в Serial1 (для отладки)//.
//#define TESTGSM1   // Раскомметировать, если нужно дублировать входящюю информацияю из serial2 (сотового телефона) в Serial1 (для отладки)
//#define TESTRM     // Раскомметировать, если нужно получать тестовые значения регулятора мощности через Serial1
//#define TESTERR   // Раскомметировать, если нужно получать тестовые значения ошибок через Serial1

//#define DEBUG // Режим отладки, в этом режиме не считываются значения датчиков температуры, а они передаются через монитор порта в ардуине
                // в формате: сколько прибавить секунд, Температура датчика 0, Температура датчика 1,Температура датчика 2
                // например: 60,820,810,800
                //  (монитор порта надо настроить так, чтобы он выдавал возврат каретки и перевод строки) 

#define USE_WDT 0 // Поставить 1, если использовать встроенный wath dog

#if USE_WDT
  #include <avr/wdt.h>
#endif

#define BEEP_LONG 20            //Длительность сигнала оповещения о состояниях процесса

#define DEBOUNCE_CYCLES 15      // Число отсчетов таймера для устранения дребезга кнопок, было 20, и, как по мне, то кнопки тормозили

#define NUM_PHASE 0    

#define KLP_HIGH 1              // Для клапанов с низким уровнем управления поменять 0 на 1

#define PEREGREV_ON 1  // Признак того, что надо использовать режим работы клапана в режиме защиты от перегрева. 1- использовать, 0-нет.

#define USE_12V_PWM 1  // Phisik: Признак того, что надо использовать защиту от перегрева 12В клапанов в версии с датчиком тока.
                       // Чтобы найти то место, где надо было вставить 5 строчек, пришлось перелопатить весь код ;) 

#define USE_GSM_WIFI             0  // Phisik: Отключаем wifi & gsm за ненадобностью, сэкономим часть памяти, удалив лишние переменные и повысив стабильность + уменьшим код на ~5%
                                    // По уму, надо разделить WiFi и GSM, т.к. WiFi ближе и понятнее, да и кода меньше занимает, но тут как-то все переплетено оказалось...

#define USE_MQTT_BROKER          0  // MQTT protocol by max506 & limon
                                    
#define USE_MPX5010_SENSOR       0  // Phisik: раньше использовалось условие #ifdef PIN_MPX5010, из-за чего приходилось постоянно следить чтобы пин был не определен

// #define USE_NPG_UROVEN_SENSORS   0  // Phisik: Тоже самое надо сделать с #ifdef NPG_UROVEN_PIN, но я этого не сделал

#if PEREGREV_ON==0
    #define PER_KLP_OPEN  1 // клапана открываем через полу-период (аналог диода), чтобы не перегревались и
    #define PER_KLP_CLOSE 1 // чтобы не быо гидроударов
#else
    #define PER_KLP_OPEN  1000 // клапана на воду переводим в фазовое управление, чтобы раз в 10 секунд на них подавалось полное напряжение, а затем напряжение
    #define PER_KLP_CLOSE 0    // из контанты NAPR_PEREGREV 150 
#endif

#define USE_ASC712       0           // Надо ли исполозовать датчик тока
#define SENSITIVE_ASC712 135   // Чувствительность датчика тока (показаний АЦП ардуино на 10 ампер тока 135 для 30А датчика, 205 для 20А датчика 82)
  
#define CNT_PERIOD       4     // Кооличество полу-периодов для обсчета среднеквадратичного.  Phisik:  не мало? может 20ть поставить?

//#define STAB_RM        1     // Поставить 1, если программе пытаться стабилизировать регулятор мощности, путем запрета вывода информации на дисплей в момент работы, чтения температуры и т.д.
                               // Поставить 0, если идет отладка программы без подключенных датчиков, контроллера детектора нуля, схемы измерения текущего напряжения в сети. 

#define USE_DIFAVTOMAT   0    // Константа, которая показывает, используется ли дифавтомат в работе системы нужно для того, чтобы при нормальном завершении процесса
                              // при плановом отключении дифавтомата не выдавалась тревога.

#define RELAY_HIGH       1           // Какой сигнал подавать на релейные выходы мешалки и разгона 
#define ALL_OFF_HIGH     1         // Какой сигнал подавать на выход ALL_OFF

//#define USE_PROVODIMOST_SR    2  // (теперь за это отвечает переменная UrovenProvodimostSR) 1 - использовать датчик проводимости спирта для контроля окончания голов, 0 - не использовать,
                                   // 2 - использовать датчик проводимости как индикатор наполнения приемной емкости с головами.
#define MAX_COUNT_PROVODIMOST_SR 6  // Количество срабатываний датчика, по достижении которых можно точно сказать, что головы закончились
                                    // Каждое значение - это 5 секунд, то есть в данном случае датчик должен показывать 30 секунд проводимость менее 20


// Аварийная сигнализация
#define USE_ALARM_UROVEN 2  // Нужно ли использовать датчик уровня в приемной емкости ардуино 1- использовать для остановки всег процесса
                            // 2 - датчик используется как уровень при котором останавливается отбор, но не останавливается ректификация
#define USE_ALARM_VODA   1  // Нужно ли использовать датчик разлития воды ардуино

#define UROVEN_ALARM 50        // Уровень сигнала, достижение котогого свидетельсвует о срабатывании аналогового датчика (в обычном состоянии он выведен на значение около 1000 для датчиков на уменьшение напряжения)
                               // или на значение около 0-10 для датчиков на увеличение напряжения 
#define COUNT_ALARM 6          // Сколько должно держаться значение уровня, чтобы сработало предупреждение каждое значение - это полсекунды.
#define COUNT_ALARM_VODA 60    // Сколько должно держаться значение разлития воды, чтобы сработала тревога каждое значение - это полсекунды.
#define COUNT_ALARM_UROVEN 200 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости каждое значение - это полсекунды.
#define COUNT_ALARM_UROVEN_FR 60 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости при фракционной перегонке каждое значение - это полсекунды.

#ifdef DEBUG
    #define COUNT_ALARM_UROVEN 20 // Сколько должно держаться значение уровня, чтобы сработала тревога по уровню в приемной емкости каждое значение - это полсекунды.
#endif

#define MAX_COUNT_NPG_ALARM 60     // Количество сработок осушения или переполнения, чтобы достоверно детектировать состояние НПГ (каждое значение -полсекунды)                                   


// Газовый сенсор
#define USE_GAS_SENSOR           0     // Надо ли использовать датчик загазованности
#define UROVEN_GAS_SENSOR        700   // Уровень сигнала, достижение котогого свидетельсвует о срабатывании датчика спиртового пара
#define COUNT_GAS_SENSOR         6     // Сколько должно держаться значение уровня, чтобы сработала тревога каждое значение - это полсекунды.
#define TIME_PROGREV_GAS_SENSOR  60    // Время для програва датчика спиртовых паров газа.

// Клапана для управления ШИМ подключены, начиная с PIN 22
// Всего максимум 5 клапанов, то есть на пины с 22 по 26 реализован
// программный ШИМ по количество полупериодов с контролем нуля.
#define MAX_KLP 5       // Количество клапанов, которыми надо управлять по ШИМ. 

#define KLP_NPG      0      // Номер клапана для управления НПГ (при дистилляции) 
#define KLP_VODA     1      // Номер клапана для управления общей подачей воды в систему
#define KLP_DEFL     2      // Номер клапана для подачи воды в дефлегматор
#define KLP_DEFL_D   2      // Номер клапана для подачи воды в дефлегматор (при дистилляции с дефлегматором с паровым отбором)
#define KLP_GLV_HVS  3      // Номер клапана отбора головных и хвостовых фракций

// С клапаном барды был косяк. Он включался в 129 процессе и мешал тестам клапанов
// см. alarm.cpp 201 строчка if (IspReg==112 || IspReg==129)
// Тк барду за меня никто не сливает, то клапан отключил, внимательно здесь!
#define KLP_BARDA    0 // 4  // Номер клапана слива барды
#define KLP_SR       4       // Номер клапана отбора ректификата
#define KLP_HLD      3       // Номер клапана холодильника (для дистилляции)
#define KLP_PB       0       // Номер клапана для слива польского буфера


// Настройка датчиков температуры
#define MAX_DS1820   5

#define TEMP_KUB       0    // Номер датчика  термометра в кубе
#define TEMP_RK20      1    // Номер датчика термометра в РК 20 см от насадки
#define TEMP_TSA       2    // Номер термометра в трубке связи с атмосферой
#define MAX_TEMP_TSA   650  // Максимальная температура в датчике ТСА
#define TEMP_DEFL      1    // Номер датчика  термометра в дефлегматоре
#define TEMP_TERMOSTAT 0    // Номер датчика  термометра термостата
#define TEMP_RAZVAR    0    // Номер датчика  термометра для разваривания зерновых

#define MAX_ERR_DS18 120    // После тридцати глюков подряд (а это тридцать секунд) от датчиков температуры, считаем, что процесс надо остановить.
#define MAX_ERR_MPX5010 120 // После 120 значений датчика давления подряд (а это 60 секунд) от датчиков температуры, считаем, что процесс надо остановить.

#define MAX_INDEX_INPUT 540

#define MAX_INDEX_BY_PERIOD 90
#define MIN_INDEX_BY_PERIOD 75


#define UDP_PROTOKOL  // Признак использования UDP протокола для обмена



// Added by Phisik on 2017-08-15
// Здесь можно отключить ненужные нам пункты в меню

// NB! Пункты 129, 130 всегда должны быть в конце! Пункт 100 - вначале!
//     Это связано с обработчиком нажатий в файле keyboard.cpp, строки 600-630

#define MENU_ITEMS 21 
const int menuEnableFlag[MENU_ITEMS] = {
  1,    // case 100:  Установка параметров  // Не отключается!
  1,    // case 101:  Displaying   // Отключается, но отключаеть не стоит
  0,    // case 102:  Термостат    
  1,    // case 103:  Регулятор мощности
  1,    // case 104:  Первый (недробный) отбор
  0,    // case 105:  Отбор голов
  0,    // case 106:  Второй дробный отбор
  0,    // case 107:  Третий дробный отбор 
  0,    // case 108:  Затор зерно
  1,    // case 109:  Ректификация
  0,    // case 110:  Дистилляция с дефлегматором
  0,    // case 111:  НДРФ
  0,    // case 112:  NBK
  0,    // case 113:  Разваривание мучно-солодового затора (без варки).
  0,    // case 114:  Разваривание с чиллером и миксером
  1,    // case 115:  Таймер + регулятор мощности
  0,    // case 116:  Пивоварня - клон браумастера
  0,    // case 117:  Фракционная перегонка
  0,    // case 118:  Ректификация Фракционная
  1,    // case 129:  Тест клапанов // Не отключается!   
  0     // case 130:  Внешнее управление
};



